// #autoload
// #name = FrostyWeapon
// #version = 0.01
// #date = July 03, 2002
// #author = Frosty
// #email = frostycubes@earthlink.net
// #description = Allows you to set different mouse sensativity levels for each weapon.
// #credit = -Blaylok - for requesting it
// #status = scripting
// #config = FrostyAConfig

if(!isObject(FrostyA))
{
    new ScriptObject(FrostyA)
    {
        class = FrostyA;
    };
}

package FrostyAxis
{
    function clientCmdSetWeaponsHudActive(%slot)
    {
        if(%slot != -1)
        {
            FrostyA.currentItem = FrostyA.getItem(%slot);
            FrostyA.setSensitivity(FrostyA.currentItem);
        }

        parent::clientCmdSetWeaponsHudActive(%slot);
    }

	function clientCmdsetRepairPackIconOn()
	{
		FrostyA.currentItem = "Repairgun";
        FrostyA.setSensitivity(FrostyA.currentItem);

		parent::clientCmdsetRepairPackIconOn();
	}

    function FrostyA::setSensitivity(%this, %item)
    {
        if(%item $= "")
            return;

        %xSens = %this.itemXAxis[%item];
        %ySens = %this.itemYAxis[%item];
        %invert = %this.itemInvert[%item] ? "SI" : "S";
        %slot = %this.getItem(%item, true);

        if(%slot <= 11 || %slot == 15 || %slot == 17)
        {
            moveMap.bind( mouse, xaxis, "S", %xSens, "yaw");
            moveMap.bind( mouse, yaxis, %invert, %ySens, "pitch");
        }
        else if(%slot >= 12)
        {
            passengerKeys.bind( mouse, xaxis, "S", %xSens, "yaw");
            passengerKeys.bind( mouse, yaxis, %invert, %ySens, "pitch");
        }
    }

    function playGui::onWake(%this)
    {
        parent::onWake(%this);

        FrostyA.setSensitivity(FrostyA.currentItem);
    }

    function FrostyA::getItem(%this, %slot, %byName)
    {
        // Weapons
        %sense[0] = "Blaster";
        %sense[1] = "Plasma";
        %sense[2] = "Chaingun";
        %sense[3] = "Disc";
        %sense[4] = "GrenadeLauncher";
        %sense[5] = "SniperRifle";
        %sense[6] = "ELFGun";
        %sense[7] = "Mortar";
        %sense[8] = "MissleLauncher";
        %sense[9] = "TargetingLaser";
        %sense[10] = "ShockLance";
        %sense[11] = "Repairgun";
        // Vehicles
        %sense[12] = "Shrike Pilot";
        %sense[13] = "Bomber Pilot";
        %sense[14] = "Bomber Bomber";
        %sense[15] = "Bomber Tailgunner";
        %sense[16] = "Transport Pilot";
        %sense[17] = "Transport Passenger";
        %sense[18] = "Assault Tank Driver";
        %sense[19] = "Assault Tank Gunner";
        %sense[20] = "Hoverbike Driver";
        %sense[21] = "MPB Driver";
        // Total Count
        %count = 22;

        if(%slot == 99)
            return %count;
        else if(%byName)
        {
            for(%i = 0;%i < %count;%i++)
            {
                if(%sense[%i] $= %slot)
                    return %i;
            }
        }
        else
            return %sense[%slot];
    }

    function clientCmdShowVehicleGauges(%vehType, %node)
    {
        switch$(%vehType)
        {
            case "Shrike" :
                FrostyA.mountVehicle("Shrike Pilot");
            case "Bomber" :
                if(%node == 0)
                    FrostyA.mountVehicle("Bomber Pilot");
                else if(%node == 1)
                    FrostyA.mountVehicle("Bomber Bomber");
                else
                    FrostyA.mountVehicle("Bomber Tailgunner");
            case "HAPC" :
                if(%node == 0)
                    FrostyA.mountVehicle("Transport Pilot");
                else
                    FrostyA.mountVehicle("Transport Passenger");
            case "Assault" :
                if(%node == 0)
                    FrostyA.mountVehicle("Assault Tank Driver");
                else
                    FrostyA.mountVehicle("Assault Tank Gunner");
            case "Hoverbike" :
                FrostyA.mountVehicle("Hoverbike Driver");
            case "MPB" :
                FrostyA.mountVehicle("MPB Driver");
        }
        parent::clientCmdShowVehicleGauges(%vehType, %node);
    }

    function FrostyA::mountVehicle(%this, %vehType)
    {
        %this.currentItem = %vehType;
        %this.setSensitivity(%vehType);
    }

    function FrostyA::setupDefaults(%this)
    {
        %this.defaultXAxis = "0.500001";
        %this.defaultYAxis = "0.500001";
        %this.defaultInvert = false;
        %this.defaultLink = true;

        for(%i = 0;%i < %this.getItem(99);%i++)
        {
            %item = %this.getItem(%i);
            %this.itemXAxis[%item] = "0.500001";
            %this.itemYAxis[%item] = "0.500001";
            %this.itemInvert[%item] = false;
            %this.itemLink[%item] = true;
        }

        %this.checkPrefs();
    }

    function FrostyA::checkPrefs(%this)
    {
        %prefs = "prefs/FrostyAxis.prefs";

        if(!isFile(%prefs))
            %this.savePrefs();
        else
            exec(%prefs);
    }

    function FrostyA::savePrefs(%this)
    {
        %prefs = "prefs/FrostyAxis.prefs";

        %file = new FileObject();
        %file.openForWrite(%prefs);
        %file.writeLine("//------------------------------------------------------------------------------------------");
        %file.writeLine("// FrostyAxis Preferences File");
        %file.writeLine("// Do not delete or edit this file! | Generated by FrostyAxis v1.0");
        %file.writeLine("//------------------------------------------------------------------------------------------");
        %file.writeLine("");

        %file.writeLine("// Default Sensativity settings");
        %file.writeLine("FrostyA.defaultXAxis = \"" @ FrostyA.defaultXAxis @ "\";");
        %file.writeLine("FrostyA.defaultYAxis = \"" @ FrostyA.defaultYAxis @ "\";");
        %file.writeLine("FrostyA.defaultInvert = \"" @ FrostyA.defaultInvert @ "\";");
        %file.writeLine("FrostyA.defaultLink = \"" @ FrostyA.defaultLink @ "\";\n");

        for(%i = 0;%i < %this.getItem(99);%i++)
        {
            %item = %this.getItem(%i);
            %file.writeLine("// " @ %item);
            %file.writeLine("FrostyA.itemXAxis[\"" @ %item @ "\"] = \"" @ FrostyA.itemXAxis[%item] @ "\";");
            %file.writeLine("FrostyA.itemYAxis[\"" @ %item @ "\"] = \"" @ FrostyA.itemYAxis[%item] @ "\";");
            %file.writeLine("FrostyA.itemInvert[\"" @ %item @ "\"] = \"" @ FrostyA.itemInvert[%item] @ "\";");
            %file.writeLine("FrostyA.itemLink[\"" @ %item @ "\"] = \"" @ FrostyA.itemLink[%item] @ "\";\n");
        }

        %file.close();
        %file.delete();
        %file = "";
    }

    function FrostyA::setupGui(%this)
    {
        if(%this.setupGui)
            return;

        new GuiControl(FrostyAConfig) {
            profile = "GuiDefaultProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "640 480";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellPaneCtrl() {
				profile = "ShellPaneProfile";
				horizSizing = "center";
				vertSizing = "center";
				position = "0 0";
				extent = "400 293";
				minExtent = "48 203";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "FrostyWeapon";
				longTextBuffer = "0";
				maxLength = "255";
				noTitleBar = "0";

				new ShellFieldCtrl() {
					profile = "ShellFieldProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "20 29";
					extent = "362 244";
					minExtent = "16 18";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
				};
        		new ShellPopupMenu(FrostyAGroupMenu) {
        			profile = "ShellPopupProfile";
        			horizSizing = "right";
        			vertSizing = "bottom";
        			position = "15 25";
        			extent = "162 36";
        			minExtent = "49 36";
        			visible = "1";
        			helpTag = "0";
                    text = "";
        			maxPopupHeight = "200";
        			buttonBitmap = "gui/shll_pulldown";
        			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
        			selectedBarBitmap = "gui/shll_pulldownbar_act";
        			noButtonStyle = "0";
        		};
    			new ShellScrollCtrl(FrostyAPane) {
    				profile = "NewScrollCtrlProfile";
    				horizSizing = "right";
    				vertSizing = "height";
    				position = "20 56";
    				extent = "160 215";
    				minExtent = "24 52";
    				visible = "1";
    				hideCursor = "0";
    				bypassHideCursor = "0";
    				helpTag = "0";
    				willFirstRespond = "1";
    				hScrollBar = "alwaysOff";
    				vScrollBar = "alwaysOn";
    				constantThumbHeight = "0";
    				defaultLineHeight = "15";
    				childMargin = "0 2";
    				fieldBase = "gui/shll_field";

    				new GuiScrollContentCtrl() {
    					profile = "GuiDefaultProfile";
    					horizSizing = "right";
    					vertSizing = "bottom";
    					position = "4 6";
    					extent = "150 215";
    					minExtent = "8 8";
    					visible = "1";
    					hideCursor = "0";
    					bypassHideCursor = "0";
    					helpTag = "0";

    					new ShellTextList(FrostyAList) {
    						profile = "ShellTextArrayProfile";
    						horizSizing = "right";
    						vertSizing = "bottom";
    						position = "0 0";
    						extent = "130 215";
    						minExtent = "8 8";
    						visible = "1";
    						hideCursor = "0";
    						bypassHideCursor = "0";
    						altCommand = "FrostyAList.selID();";
    						helpTag = "0";
    						enumerate = "0";
    						resizeCell = "1";
    						columns = "2 150";
    						fitParentWidth = "1";
    						clipColumnText = "0";
    					};
				    };
			    };
        		new GuiTextCtrl() {
        			profile = "ShellTextProfile";
        			horizSizing = "right";
        			vertSizing = "bottom";
        			position = "181 66";
        			extent = "94 22";
        			minExtent = "8 8";
        			visible = "1";
        			helpTag = "0";
        			text = "X-Axis Sensitivity:";
        		};
        		new GuiTextCtrl(FrostyAXAxisValue) {
        			profile = "ShellAltTextProfile";
        			horizSizing = "right";
        			vertSizing = "bottom";
        			position = "280 66";
        			extent = "28 20";
        			minExtent = "8 8";
        			visible = "1";
        			helpTag = "0";
        			text = "(0.5)";
        		};
        		new ShellSliderCtrl(FrostyAXAxisSlider) {
        			profile = "ShellSliderProfile";
        			horizSizing = "right";
        			vertSizing = "bottom";
        			position = "196 81";
        			extent = "170 24";
        			minExtent = "12 24";
        			visible = "1";
        			variable = "value";
        			altCommand = "FrostyAXAxisSlider.sync();";
        			helpTag = "0";
        			range = "0.000000 1.000000";
        			ticks = "1000";
        			value = "0.480769";
        			usePlusMinus = "1";
        		};
        		new ShellToggleButton(FrostyALinkBtn) {
        			profile = "ShellRadioProfile";
        			horizSizing = "right";
        			vertSizing = "bottom";
        			position = "314 103";
        			extent = "61 30";
        			minExtent = "26 27";
        			visible = "1";
        			helpTag = "0";
        			text = "LINK";
        		};
        		new GuiTextCtrl() {
        			profile = "ShellTextProfile";
        			horizSizing = "right";
        			vertSizing = "bottom";
        			position = "181 115";
        			extent = "93 22";
        			minExtent = "8 8";
        			visible = "1";
        			helpTag = "0";
        			text = "Y-Axis Sensitivity:";
        		};
        		new GuiTextCtrl(FrostyAYAxisValue) {
        			profile = "ShellAltTextProfile";
        			horizSizing = "right";
        			vertSizing = "bottom";
        			position = "280 115";
        			extent = "28 20";
        			minExtent = "8 8";
        			visible = "1";
        			helpTag = "0";
        			text = "(0.5)";
        		};
        		new ShellSliderCtrl(FrostyAYAxisSlider) {
        			profile = "ShellSliderProfile";
        			horizSizing = "right";
        			vertSizing = "bottom";
        			position = "196 130";
        			extent = "170 24";
        			minExtent = "12 24";
        			visible = "1";
        			variable = "value";
        			altCommand = "FrostyAYAxisSlider.sync();";
        			helpTag = "0";
        			range = "0.000000 1.000000";
        			ticks = "1000";
        			value = "0.480769";
        			usePlusMinus = "1";
        		};
        		new ShellToggleButton(FrostyAInvertBtn) {
        			profile = "ShellRadioProfile";
        			horizSizing = "right";
        			vertSizing = "bottom";
        			position = "203 168";
        			extent = "140 30";
        			minExtent = "26 27";
        			visible = "1";
        			helpTag = "0";
        			text = "INVERT Y-AXIS";
        		};
        		new ShellBitmapButton(FrostyASetDefaultBtn) {
        			profile = "ShellButtonProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "227 200";
        			extent = "100 38";
        			minExtent = "32 38";
        			visible = "1";
                    hideCursor = "0";
                    bypassHideCursor = "0";
        			command = "FrostyA.setToDefault();";
        			helpTag = "0";
        			text = "Set To Default";
        			simpleStyle = "0";
        		};
        		new ShellBitmapButton(FrostyASaveDefaultBtn) {
        			profile = "ShellButtonProfile";
        			horizSizing = "right";
        			vertSizing = "top";
        			position = "227 230";
        			extent = "100 38";
        			minExtent = "32 38";
        			visible = "1";
                    hideCursor = "0";
                    bypassHideCursor = "0";
        			command = "FrostyA.saveAsDefault();";
        			helpTag = "0";
        			text = "Save As Default";
        			simpleStyle = "0";
        		};
            };
        };

        %this.setupGui = true;
    }

    function FrostyAConfig::onWake(%this)
    {
        FrostyAList.rebuild(0);
        FrostyAGroupMenu.clear();

        FrostyAGroupMenu.add("Weapons", 0);
        FrostyAGroupMenu.add("Vehicles", 1);

        FrostyAGroupMenu.setSelected(0);
    }

    function FrostyAGroupMenu::onSelect(%this, %id, %name)
    {
        FrostyA.group = %id;
        FrostyAList.rebuild(%id);
    }

    function FrostyAList::rebuild(%this, %id)
    {
        %start = %id == 0 ? 0 : 12;
        %end = %id == 0 ? 12 : 22;

        %this.clear();
        for(%i = %start;%i < %end;%i++)
        {
            %this.addRow(%i, FrostyA.getItem(%i));
        }
        %this.setSelectedRow(0);
    }

    function FrostyAList::onSelect(%this)
    {
        %this.selID();
    }

    function FrostyA::setToDefault(%this)
    {
        // Name of weapon/vehicle selected
        %item = %this.itemListSelected;
        %this.itemLink[%item] = %this.defaultLink;
        %this.itemInvert[%item] = %this.defaultInvert;

        FrostyAXAxisValue.setValue("(" @ getSubStr(%this.defaultXAxis, 0, 4) @ ")");
        FrostyAXAxisSlider.setValue(%this.defaultXAxis);
        FrostyALinkBtn.setValue(%this.defaultLink);
        FrostyAYAxisValue.setValue("(" @ getSubStr(%this.defaultYAxis, 0, 4) @ ")");
        FrostyAYAxisSlider.setValue(%this.defaultYAxis);
        FrostyAInvertBtn.setValue(%this.defaultInvert);
    }

    function FrostyA::saveAsDefault(%this)
    {
        %this.defaultXAxis = FrostyAXAxisSlider.getValue();
        %this.defaultLink = FrostyALinkBtn.getValue();
        %this.defaultYAxis = FrostyAYAxisSlider.getValue();
        %this.defaultInvert = FrostyAInvertBtn.getValue();
    }

    function FrostyAList::selID(%this)
    {
        // Name of weapon/vehicle selected
        %item = %this.getValue();
        FrostyA.itemListSelected = %item;

        // Set the options GUI to current weapon
        FrostyAXAxisValue.setValue("(" @ getSubStr(FrostyA.itemXAxis[%item], 0, 4) @ ")");
        FrostyAXAxisSlider.setValue(FrostyA.itemXAxis[%item]);
        FrostyALinkBtn.setValue(FrostyA.itemLink[%item]);
        FrostyAYAxisValue.setValue("(" @ getSubStr(FrostyA.itemYAxis[%item], 0, 4) @ ")");
        FrostyAYAxisSlider.setValue(FrostyA.itemYAxis[%item]);
        FrostyAInvertBtn.setValue(FrostyA.itemInvert[%item]);
    }

    function FrostyAXAxisSlider::sync(%this)
    {
        %value = %this.getValue();
        %item = FrostyA.itemListSelected;
        FrostyAXAxisValue.setValue("(" @ getSubStr(%value, 0, 4) @ ")");
        FrostyA.itemXAxis[%item] = %value;
        if(FrostyA.itemLink[%item])
        {
            if(FrostyAYAxisSlider.getValue() != %value)
                FrostyAYAxisSlider.setValue(%value);
        }
    }

    function FrostyAYAxisSlider::sync(%this)
    {
        %value = %this.getValue();
        %item = FrostyA.itemListSelected;
        FrostyAYAxisValue.setValue("(" @ getSubStr(%value, 0, 4) @ ")");
        FrostyA.itemYAxis[%item] = %value;
        if(FrostyA.itemLink[%item])
        {
            if(FrostyAXAxisSlider.getValue() != %value)
                FrostyAXAxisSlider.setValue(%value);
        }
    }

    function FrostyAInvertBtn::onAction(%this)
    {
        %value = %this.getValue();
        %item = FrostyA.itemListSelected;
        FrostyA.itemInvert[%item] = %value;
    }

    function FrostyALinkBtn::onAction(%this)
    {
        %value = %this.getValue();
        %item = FrostyA.itemListSelected;
        FrostyA.itemLink[%item] = %value;
    }

    function quit()
    {
        FrostyA.savePrefs();

        parent::quit();
    }
};
activatePackage(FrostyAxis);

if($AutoLoadExecuted)
    FrostyA.setupGui();

FrostyA.setupDefaults();
